# TODO:
# - consider doing subpackages for all those plugins (which one should be in main package ?)
# - desktop file (icon exists, but no desktop file?)
#
# Conditional build:
# Features
%bcond_without	aspell	# don't build aspell support
%bcond_without	doc	# don't build docs
# Bindings
%bcond_without	guile	# don't enable Scheme (guile) scripting language
%bcond_without	lua	# don't enable Lua scripting language
%bcond_without	perl	# don't enable Perl scripting language
%bcond_with	php	# don't enable PHP scripting language
%bcond_without	python	# don't enable Python scripting language
%bcond_without	ruby	# don't enable Ruby scripting language
%bcond_without	tcl	# don't enable Tcl scripting language
%bcond_without	js	# don't enable JavaScript scripting language (V8 engine)

%ifnarch %{ix86} %{x8664} arm mips
%undefine	with_js
%endif

%define		php_name	php%{?php_suffix}

Summary:	WeeChat - fast and light chat environment
Summary(pl.UTF-8):	WeeChat - szybkie i lekkie środowisko do rozmów
Name:		weechat
Version:	4.6.3
Release:	1
License:	GPL v3+
Group:		Applications/Communications
Source0:	https://www.weechat.org/files/src/%{name}-%{version}.tar.xz
# Source0-md5:	96dc2d0d883cf61f504144552f30dd31
URL:		http://www.weechat.org/
%{?with_aspell:BuildRequires:	aspell-devel}
BuildRequires:	cjson-devel
BuildRequires:	cmake >= 3.18
BuildRequires:	curl-devel
BuildRequires:	gettext-tools
BuildRequires:	gnutls-devel
%{?with_guile:BuildRequires:	guile-devel}
BuildRequires:	libgcrypt-devel
%{?with_lua:BuildRequires:	lua-devel}
BuildRequires:	ncurses-devel
%{?with_perl:BuildRequires:	perl-devel}
%{?with_php:BuildRequires:	%{php_name}-devel >= 4:7}
BuildRequires:	pkgconfig
%if %{with python}
BuildRequires:	python3-devel
BuildRequires:	python3-modules
%endif
BuildRequires:	rpm-build >= 4.6
BuildRequires:	rpmbuild(macros) >= 1.752
%{?with_doc:BuildRequires:	ruby-asciidoctor}
%{?with_ruby:BuildRequires:	ruby-devel >= 1:1.9}
BuildRequires:	sed >= 4.0
BuildRequires:	tar >= 1:1.22
%{?with_tcl:BuildRequires:	tcl-devel}
%{?with_js:BuildRequires:	v8-devel}
BuildRequires:	xz
BuildRequires:	zlib-devel
BuildRequires:	zstd-devel
Requires(post,postun):	desktop-file-utils
Suggests:	%{name}-icons
Suggests:	%{name}-plugin-irc
Obsoletes:	weechat-common < 1.2
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		skip_post_check_so	ruby.so.0.0.0

%description
WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat
environment for many operating systems. Everything can be done with a
keyboard. It is customizable and extensible with scripts.

%description -l pl.UTF-8
WeeChat (Wee Ehanced Environment for Chat) to szybkie i lekkie
środowisko do rozmów dla wielu systemów operacyjnych. Pozwala wszystko
zrobić przy pomocy klawiatury. Jest konfigurowalne i rozszerzalne za
pomocą skryptów.

%package doc
Summary:	Manual for weechat
Group:		Documentation
BuildArch:	noarch

%description doc
HTML documentation for weechat.

%package icons
Summary:	Icon files for weechat
Group:		Applications
BuildArch:	noarch
Requires(post,postun):	gtk-update-icon-cache

%description icons
Icon files for weechat.

%package plugin-guile
Summary:	Guile scripting plugin for weechat
Group:		Applications/Communications
Requires:	%{name} = %{version}-%{release}

%description plugin-guile
Guile scripting plugin for weechat.

%package plugin-irc
Summary:	IRC chat protocol plugin for weechat
Group:		Applications/Communications
Requires:	%{name} = %{version}-%{release}

%description plugin-irc
IRC chat protocol plugin for weechat.

%package plugin-javascript
Summary:	JavaScript scripting plugin for weechat
Group:		Applications/Communications
Requires:	%{name} = %{version}-%{release}

%description plugin-javascript
JavaScript scripting plugin for weechat.

%package plugin-lua
Summary:	Lua scripting plugin for weechat
Group:		Applications/Communications
Requires:	%{name} = %{version}-%{release}

%description plugin-lua
Lua scripting plugin for weechat.

%package plugin-perl
Summary:	Perl scripting plugin for weechat
Group:		Applications/Communications
Requires:	%{name} = %{version}-%{release}

%description plugin-perl
Perl scripting plugin for weechat.

%package plugin-python
Summary:	Python scripting plugin for weechat
Group:		Applications/Communications
Requires:	%{name} = %{version}-%{release}

%description plugin-python
Python scripting plugin for weechat.

%package plugin-relay
Summary:	Relay data via network plugin for weechat
Group:		Applications/Communications
Requires:	%{name} = %{version}-%{release}

%description plugin-relay
Relay data via network plugin for weechat used by alternative
frontends.

%package plugin-ruby
Summary:	Ruby scripting plugin for weechat
Group:		Applications/Communications
Requires:	%{name} = %{version}-%{release}

%description plugin-ruby
Ruby scripting plugin for weechat.

%package plugin-spell
Summary:	Spell checking plugin for weechat
Group:		Applications/Communications
Requires:	%{name} = %{version}-%{release}

%description plugin-spell
Spell checking plugin for weechat.

%package plugin-tcl
Summary:	Tcl scripting plugin for weechat
Group:		Applications/Communications
Requires:	%{name} = %{version}-%{release}

%description plugin-tcl
Tcl scripting plugin for weechat.

%package plugin-xfer
Summary:	File transfer and direct chat plugin for weechat
Group:		Applications/Communications
Requires:	%{name} = %{version}-%{release}

%description plugin-xfer
File transfer and direct chat plugin for weechat.

%prep
%setup -q

%build
install -d build
cd build
%cmake \
	-DPREFIX=%{_prefix} \
	-DLIBDIR=%{_libdir} \
	-DENABLE_HEADLESS=ON \
	-DENABLE_DOC_INCOMPLETE=ON \
	-DENABLE_NCURSES=ON \
	%{cmake_on_off aspell ENABLE_SPELL} \
	%{cmake_on_off doc ENABLE_DOC} \
	%{cmake_on_off perl ENABLE_PERL} \
	%{cmake_on_off php ENABLE_PHP} \
	%{cmake_on_off python ENABLE_PYTHON} \
	%{cmake_on_off ruby ENABLE_RUBY} \
	%{cmake_on_off lua ENABLE_LUA} \
	%{cmake_on_off guile ENABLE_GUILE} \
	%{cmake_on_off tcl ENABLE_TCL} \
	%{cmake_on_off doc ENABLE_MAN} \
	%{cmake_on_off js ENABLE_JAVASCRIPT} \
	..

%{__make} VERBOSE=1

%install
rm -rf $RPM_BUILD_ROOT
%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{_datadir}/weechat/{guile,javascript,lua,perl,python,ruby,tcl}

# symlink to "weechat"
%{__rm} $RPM_BUILD_ROOT%{_bindir}/weechat-curses

# no -devel, drop
%{__rm} -r $RPM_BUILD_ROOT%{_includedir}/%{name}
%{__rm} $RPM_BUILD_ROOT%{_pkgconfigdir}/%{name}.pc

%find_lang %{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_desktop_database
%update_mime_database

%post icons
%update_icon_cache hicolor

%postun
%update_desktop_database_postun
%update_mime_database

%postun icons
%update_icon_cache hicolor

%files -f %{name}.lang
%defattr(644,root,root,755)
%doc AUTHORS.md CHANGELOG.md README.md UPGRADING.md
%attr(755,root,root) %{_bindir}/weechat
%attr(755,root,root) %{_bindir}/weechat-headless
%dir %{_datadir}/weechat
%if %{with doc}
%{_mandir}/man1/weechat.1*
%{_mandir}/man1/weechat-headless.1*
%lang(cs) %{_mandir}/cs/man1/weechat.1*
%lang(cs) %{_mandir}/cs/man1/weechat-headless.1*
%lang(de) %{_mandir}/de/man1/weechat.1*
%lang(de) %{_mandir}/de/man1/weechat-headless.1*
%lang(fr) %{_mandir}/fr/man1/weechat.1*
%lang(fr) %{_mandir}/fr/man1/weechat-headless.1*
%lang(it) %{_mandir}/it/man1/weechat.1*
%lang(it) %{_mandir}/it/man1/weechat-headless.1*
%lang(ja) %{_mandir}/ja/man1/weechat.1*
%lang(ja) %{_mandir}/ja/man1/weechat-headless.1*
%lang(pl) %{_mandir}/pl/man1/weechat.1*
%lang(pl) %{_mandir}/pl/man1/weechat-headless.1*
%lang(ru) %{_mandir}/ru/man1/weechat.1*
%lang(ru) %{_mandir}/ru/man1/weechat-headless.1*
%lang(sr) %{_mandir}/sr/man1/weechat.1*
%lang(sr) %{_mandir}/sr/man1/weechat-headless.1*
%endif
%{_desktopdir}/%{name}.desktop

%dir %{_libdir}/%{name}
%dir %{_libdir}/%{name}/plugins
%attr(755,root,root) %{_libdir}/%{name}/plugins/alias.so
%attr(755,root,root) %{_libdir}/%{name}/plugins/buflist.so
%attr(755,root,root) %{_libdir}/%{name}/plugins/charset.so
%attr(755,root,root) %{_libdir}/%{name}/plugins/exec.so
%attr(755,root,root) %{_libdir}/%{name}/plugins/fifo.so
%attr(755,root,root) %{_libdir}/%{name}/plugins/fset.so
%attr(755,root,root) %{_libdir}/%{name}/plugins/logger.so
%attr(755,root,root) %{_libdir}/%{name}/plugins/script.so
%attr(755,root,root) %{_libdir}/%{name}/plugins/trigger.so
%attr(755,root,root) %{_libdir}/%{name}/plugins/typing.so

%files icons
%defattr(644,root,root,755)
%{_iconsdir}/hicolor/*/apps/weechat.png

%if %{with doc}
%files doc
%defattr(644,root,root,755)
%dir %{_docdir}/%{name}
%lang(cs) %{_docdir}/%{name}/*.cs.html
%lang(de) %{_docdir}/%{name}/*.de.html
%lang(en) %{_docdir}/%{name}/*.en.html
%lang(es) %{_docdir}/%{name}/*.es.html
%lang(fr) %{_docdir}/%{name}/*.fr.html
%lang(it) %{_docdir}/%{name}/*.it.html
%lang(ja) %{_docdir}/%{name}/*.ja.html
%lang(pl) %{_docdir}/%{name}/*.pl.html
%lang(ru) %{_docdir}/%{name}/*.ru.html
%lang(sr) %{_docdir}/%{name}/*.sr.html
%endif

%if %{with guile}
%files plugin-guile
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/%{name}/plugins/guile.so
%dir %{_datadir}/weechat/guile
%endif

%files plugin-irc
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/%{name}/plugins/irc.so

%if %{with js}
%files plugin-javascript
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/%{name}/plugins/javascript.so
%dir %{_datadir}/weechat/javascript
%endif

%if %{with lua}
%files plugin-lua
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/%{name}/plugins/lua.so
%dir %{_datadir}/weechat/lua
%endif

%if %{with perl}
%files plugin-perl
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/%{name}/plugins/perl.so
%dir %{_datadir}/weechat/perl
%endif

%if %{with python}
%files plugin-python
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/%{name}/plugins/python.so
%dir %{_datadir}/weechat/python
%endif

%files plugin-relay
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/%{name}/plugins/relay.so

%if %{with ruby}
%files plugin-ruby
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/%{name}/plugins/ruby.so
%dir %{_datadir}/weechat/ruby
%endif

%if %{with aspell}
%files plugin-spell
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/%{name}/plugins/spell.so
%endif

%if %{with tcl}
%files plugin-tcl
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/%{name}/plugins/tcl.so
%dir %{_datadir}/weechat/tcl
%endif

%files plugin-xfer
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/%{name}/plugins/xfer.so
%changelog
* Sun May 11 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/weechat.git;a=log;h=master

* Sun May 11 2025 Jan Palus <atler@pld-linux.org> e7378b7
- up to 4.6.3

* Sat Apr 19 2025 Jan Palus <atler@pld-linux.org> 91e7782
- up to 4.6.2

* Wed Apr 09 2025 Jan Palus <atler@pld-linux.org> 0192336
- up to 4.6.1

* Sun Mar 23 2025 Jan Palus <atler@pld-linux.org> 1763d8f
- up to 4.6.0

* Mon Mar 10 2025 Jan Rękorajski <baggins@pld-linux.org> e9fd4d5
- python 3.13 rebuild

* Mon Dec 23 2024 Jan Palus <atler@pld-linux.org> 4616f08
- up to 4.5.1

* Mon Dec 16 2024 Jan Palus <atler@pld-linux.org> ec71aa4
- up to 4.5.0

* Sat Nov 30 2024 Jan Palus <atler@pld-linux.org> f600618
- up to 4.4.4

* Wed Oct 30 2024 Jan Palus <atler@pld-linux.org> a198a89
- up to 4.4.3

* Sun Sep 08 2024 Jan Palus <atler@pld-linux.org> df0a87b
- up to 4.4.2

* Sat Aug 17 2024 Jan Palus <atler@pld-linux.org> e62a2bf
- up to 4.4.0

* Thu Aug 15 2024 Jan Palus <atler@pld-linux.org> aa4e3e1
- up to 4.3.6

* Wed Jul 17 2024 Jan Palus <atler@pld-linux.org> d66fb57
- up to 4.3.5

* Wed Jul 03 2024 Jan Palus <atler@pld-linux.org> 8aaabe1
- up to 4.3.4

* Sat Jun 29 2024 Jan Palus <atler@pld-linux.org> c0625be
- perl 5.40.0 rebuild

* Sun Jun 23 2024 Jan Palus <atler@pld-linux.org> 62f11ea
- up to 4.3.3

* Thu Jun 06 2024 Jan Palus <atler@pld-linux.org> 0b19021
- up to 4.3.2

* Fri May 31 2024 Jan Palus <atler@pld-linux.org> bdf03ae
- up to 4.3.1

* Mon May 27 2024 Jan Palus <atler@pld-linux.org> e5f3983
- up to 4.3.0

* Mon Apr 08 2024 Jan Palus <atler@pld-linux.org> 0e109e8
- up to 4.2.2

